﻿/// <reference path="jquery/jquery-1.6.2.min.js" />
/// <reference path="jquery-ui/jquery-ui-1.8.11.min.js" />
/// <reference path="jQueryRotate/jQueryRotate.2.1.js" />
/// <reference path="nevo-slider/jquery.nivo.slider.pack.js" />

var mouseX = -1;
var mouseY = -1;
var centerX = -1;
var centerY = -1;
var startX = -1;
var startY = -1;
var curAngle = 0;
var rotating = false;

function wrapd(_val, _min, _max)
{
    if(_val < _min) return _max - (_min - _val);
    if(_val > _max) return _min - (_max - _val);
    return _val;
}

jQuery.fn.reverse = function () {
    return this.pushStack(this.get().reverse(), arguments);
};


function startRotation(e) {
    rotating = true;
    mouseX = e.pageX;
    mouseY = e.pageY;
    startX = mouseX;
    startY = mouseY;
    centerX = $("#imgRuler").offset().left + $("#imgRuler").width() / 2;
    centerY = $("#imgRuler").offset().top + $("#imgRuler").height() / 2;
    e.preventDefault();
}

$(document).ready(function () {

    $(document).mouseup(function (e) {
        if (rotating) {
            mouseX = e.pageX;
            mouseY = e.pageY;
            var fromAngle = Math.atan2(startY - centerY, startX - centerX);
            var toAngle = Math.atan2(mouseY - centerY, mouseX - centerX);
            var newAngle = wrapd(curAngle + (toAngle - fromAngle), 0, 2 * 3.14);
            curAngle = newAngle;
            mouseX = -1;
            mouseY = -1;
            startX = -1;
            startY = -1;
            rotating = false;
            $("#imgRuler").unbind("mousedown");
            $("#imgRuler").bind("mousedown", function (e) {
                startRotation(e);
            });
        }
    });

    $("#imgRuler").bind("mousedown", function (e) {
        startRotation(e);
    });

    if ($.support.opacity == true) {
        $("#imgRuler").bind("mouseenter", function (e) {
            $("#pDragHandle").stop(true, true);
            $("#pDragHandle").fadeIn();
        });

        $("#imgRuler").bind("mouseout", function (e) {
            var strId = new String(e.relatedTarget.id);
            if (strId.indexOf("DragHandle") == -1) {
                $("#pDragHandle").stop(true, true);
                $("#pDragHandle").fadeOut();
            }
        });
    }

    $(document).mousemove(function (e) {
        if (rotating) {
            mouseX = e.pageX;
            mouseY = e.pageY;

            var fromAngle = Math.atan2(startY - centerY, startX - centerX);
            var toAngle = Math.atan2(mouseY - centerY, mouseX - centerX);
            var angle = wrapd(curAngle + (toAngle - fromAngle), 0, 2 * 3.14);
            angle = angle * (180 / Math.PI);

            $("#imgRuler").rotate(angle);
        }
    });

    //$("#divRuler").draggable({ handle: "p", containment: "#desktop", scroll: false });
    $("#divRuler").draggable({ handle: "p", scroll: false });


    $(window).load(function () {

        $('#slider').nivoSlider({
            manualAdvance: true,
            directionNav: false,
            effect: 'random'
        });

        $("#pDragHandle").css("position", "absolute");
        $("#pDragHandle").css("top", "0px");
        var left = (($("#imgRuler").width() / 2) - ($("#pDragHandle").width() / 2)).toString() + "px";
        $("#pDragHandle").css("left", left);
        $("#pDragHandle").css("top", "5px");

        if ($.support.opacity == true)
            $("#pDragHandle").fadeOut();

        $("#divRuler").css("visibility", "visible");


    });
});